###
#
# Listen is the legal property of mehdi abaakouk <theli48@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###


# Simple proxy to a Python ConfigParser.
import os
# We don't need/want variable interpolation.
from ConfigParser import RawConfigParser as ConfigParser

_config = ConfigParser()
get = _config.get
set = _config.set
getboolean = _config.getboolean
getint = _config.getint
getfloat = _config.getfloat
write = _config.write
options = _config.options

VERSION = "0.2"

GETTEXT_APP="listen"
GETTEXT_DIR = "po"
CONFIG_DIR  = os.path.expanduser("~/.listen/")
if not os.path.isdir(CONFIG_DIR+"/cover"):
    os.makedirs(CONFIG_DIR+"/cover")
CONFIG_FILE  = os.path.join(CONFIG_DIR, "config")
TAG_COMPLETITION_FILE  = os.path.join(CONFIG_DIR, "tag_completition")
PIXMAP_DIR = "images/"

TMP_PATH = "/tmp/listen/"
if not os.path.isdir(TMP_PATH):
    os.makedirs(TMP_PATH)

def write(filename):
    if isinstance(filename, str):
        if not os.path.isdir(os.path.dirname(filename)):
            os.makedirs(os.path.dirname(filename))
        f = file(filename, "w")
    else: f = filename
    _config.write(f)
    f.close()

def init(*rc_files):
    initial = {
        # State about the player, to restore on startup
        "setting":
        {
          "splash": "true",
          "start_trayicon": "false",
          "reduire_trayicon": "true",
          "fermer_trayicon": "false",
          "use_trayicon": "true",
          "mlib_smallfont": "false",
          "window_state" : "widthdrawn",
          "media_organizer" : "false",
          "media_organizer_item" : "0",
          "width" : "-1",
          "height" : "-1",
          "pos_x" : "-1",
          "pos_y" : "-1",
          "pos_browser" : "170",
          "pos_organizer" : "140",
          "repeat_mode":"false",
          "last_selected_artist":"",
          "last_selected_album":"",
          "volume":"1",
          "wikipedia":"en",
          "empty_random":"false"


        },
        "osd":
        {
            "osd_enable": "true",
            "osd_custom_position": "-1 -1",
            #"osd_colors": "#898877 #858472 #3a3934 #e4e2d4",
            "osd_colors": "#ffffff #ffffff #ffffff #2959ac",

            #"osd_colors": "#80869d #4d515f #000000 #4d515f",
            "osd_font": "Comic Sans MS Bold 18",
            "osd_timeout": "7.5",
            "osd_transparency": "215",
            "osd_center_x": "1",
            "osd_center_y": "0",
        }
    }

    """
        ,
        daap":
        {
          #  "Nana": "192.168.0.200:3689",
            "Theli": "192.168.0.100:3689"
        }
    """

    for section, values in initial.iteritems():
        _config.add_section(section)
        for key, value in values.iteritems():
            _config.set(section, key, value)

    _config.read(rc_files)

def state(arg):
    return _config.getboolean("settings", arg)
