###
#
# Listen is the legal property of mehdi abaakouk <theli48@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###

import gtk
import gobject
import gtkhtml2
import urllib
from xml.dom import minidom
import re
import threading

import config
import stock
import utils
from web_manager import *
from misc_widget import get_scrolled_window

#FIXME: need change leolyrics auth

WIKI_HOTE = "%s.wikipedia.org"
WIKI_URL = WIKI_HOTE+"/wiki/"

class ListenWikiPedia(gtk.VBox):
    def __init__(self,media_organizer):
        gtk.VBox.__init__(self,False,6)
        self.set_border_width(6)
        self.player = media_organizer.player
        self.player.gst_player.connect("new-media",self.media_media_cb)

        self.last_action = "artist"
        self.song = None
        self.url_back = []
        self.url_forward = []
        self.current_url = None

        self.document_wiki = HTMLDocument()
        self.document_wiki.connect('link_clicked', self.link_clicked)

        self.document_info = HTMLDocument()
        self.document_info.connect('link_clicked', self.link_clicked)

        HTML_PRESENTATION = HTML_TEMPLATE%("""
            """)
        self.document_info.open_stream('text/html')
        self.document_info.write_stream(HTML_PRESENTATION)
        self.document_info.close_stream()


        self.view = gtkhtml2.View()
        self.view.set_document(self.document_info)
        self.view.set_magnification(1)

        self.btn_forward = self.make_btn(gtk.STOCK_GO_FORWARD,"forward")
        self.btn_back = self.make_btn(gtk.STOCK_GO_BACK,"back")
        self.btn_artist = self.make_btn(stock.USERS,"artist",_("Artist"))
        self.btn_artist.set_active(True)
        self.btn_album = self.make_btn(stock.CD,"album",_("Album"),self.btn_artist)
        self.btn_title = self.make_btn(gtk.STOCK_DIALOG_INFO,"title",_("Song")+"   ",self.btn_artist)

        self.btn_browser = gtk.Button()
        self.btn_browser.add(gtk.image_new_from_icon_name("stock_internet", gtk.ICON_SIZE_LARGE_TOOLBAR))
        self.btn_browser.connect("clicked",self.open_in_browser)

        model = gtk.ListStore(gobject.TYPE_STRING)

        self.dropdown_lang = gtk.combo_box_new_text()
        langs = ["en","fr","de","es","it","nl","sv","pl","pt"]
        for lang in langs:
            if lang == config.get("setting","wikipedia"):
                active = langs.index(lang)
                self.lang=lang
            self.dropdown_lang.append_text(lang)

        self.dropdown_lang.set_active(active)
        self.dropdown_lang.connect("changed",self.on_change_lang)

        self.update_btn_status()

        hbox = gtk.HBox(False,6)
        hbox.pack_end(self.dropdown_lang,False,False)
        hbox.pack_end(self.btn_forward,False,False)
        hbox.pack_end(self.btn_back,False,False)
        hbox.pack_end(self.btn_browser,False,False)

        hbox.pack_start(self.btn_artist,False,False)
        hbox.pack_start(self.btn_album,False,False)
        hbox.pack_start(self.btn_title,False,False)

        self.pack_start(hbox,False,False)
        self.pack_start(get_scrolled_window(self.view))
        self.site_cache={}

    def open_in_browser(self,btn=None):
        if self.current_url!=None:
            utils.website(self.current_url);

    #While i search how to fix segmentation fault
    #(Due when to stream in the same document)
    #Search how to plug the cancel stream function
    #For now i create 1 doc / stream(page)
    def get_new_document(self):
        document = HTMLDocument()
        document.connect('link_clicked', self.link_clicked)
        document.set_base_uri("http://"+WIKI_HOTE%self.lang+"/")
        return document

    def on_change_lang(self,widget):
        self.lang = self.dropdown_lang.get_active_text()
        config.set("setting","wikipedia",self.lang)
        self.fetch_information(None,self.last_action)

    def set_action(self,action):
        if action=="artist":
            self.btn_artist.connect("clicked",lambda x: None)
            self.btn_artist.clicked()
            self.btn_artist.connect("clicked",self.fetch_information,action)
        if action=="album":
            self.btn_album.connect("clicked",lambda x: None)
            self.btn_album.clicked()
            self.btn_album.connect("clicked",self.fetch_information,action)
        if action=="title":
            self.btn_title.connect("clicked",lambda x: None)
            self.btn_title.clicked()
            self.btn_title.connect("clicked",self.fetch_information,action)


    def make_btn(self,stocks,action,label=None,btn=None):
        if label==None:
           btn = gtk.Button()
           image = gtk.image_new_from_stock(stocks, gtk.ICON_SIZE_BUTTON)
           btn.add(image)
        else:
           btn = gtk.RadioButton(group=btn)
           image = gtk.image_new_from_stock(stocks, gtk.ICON_SIZE_BUTTON)
           label = gtk.Label(label)
           label.set_alignment(0,0.5)
           box = gtk.HBox(False,6)
           box.pack_start(image,False,False)
           box.pack_start(label,True,True)
           btn.add(box)


        btn.connect("clicked",self.fetch_information,action)
        return btn

    def media_media_cb(self,widget,song):
        self.song = song
        self.fetch_information(None,self.last_action)

    def update_btn_status(self):
        if len(self.url_back)==0:
            self.btn_back.set_sensitive(False)
        else:
            self.btn_back.set_sensitive(True)
        if len(self.url_forward)==0:
            self.btn_forward.set_sensitive(False)
        else:
            self.btn_forward.set_sensitive(True)

    def fetch_information(self,btn,action):

        if action in ["artist","album","title"]:
            self.last_action=action
            if self.song==None:
                return
            url = "http://"+(WIKI_URL%self.lang)+urllib.quote(self.song.sprint(action).encode("utf-8"))
            if str(url) == str(self.current_url):
                return

            self.document_info.clear()
            self.document_info.open_stream('text/html')
            msg =  _("Fetching informations from")+" <b>\""+(WIKI_HOTE%self.lang)+"\"</b>"
            HTML = HTML_TEMPLATE%("<h3>"+msg.encode("utf-8")+"<br>"+_("About ")+" <b>\"%s\"</b></h3>"%self.song.sprint(action))
            self.document_info.write_stream(HTML)
            self.document_info.close_stream()
            self.view.set_document(self.document_info)

            clear_forward = True
            update_nav = True

        elif action=="back":
            #Ecrire un tableau de lien des
            url = self.url_back.pop()
            if self.current_url !=None:
                self.url_forward.append(self.current_url)
            clear_forward = False
            update_nav = False

        elif action=="forward":
            url = self.url_forward.pop()
            clear_forward = False
            update_nav = True


        thread = threading.Thread(target=self.link_clicked,args=(self.get_new_document(),url,clear_forward,update_nav))
        thread.setDaemon(True)
        thread.start()


    def link_clicked(self,document, link,clear_forward=True,update_nav=True):
        if str(link) == str(self.current_url):
            return
        if clear_forward:
            self.url_forward = []
        if self.current_url !=None and update_nav:
            self.url_back.append(self.current_url)

        if self.site_cache.has_key(link):
            html = self.site_cache[link]
        else:
            f = document.open_url(link)
            if f==None:
                return

            gobject.idle_add(self.update_btn_status)
            document.clear()
            headers = f.info()
            mime = headers.getheader('Content-type')
            if mime:
                document.open_stream(mime)
            else:
                document.open_stream('text/plain')
            html = f.read()
            html = html[html.find("<body"):html.find("</body>")]
            #html = re.sub('<(.*)>', "", html)
            html = re.sub("class=\"(.[^>]*)\"","",html)
            html = re.sub("id=\"(.[^>]*)\"","",html)
            html = re.sub("style=\"(.[^>]*)\"","",html)
            #html = re.sub("<input(.[^>]*)>","",html)
            #print html

            html = HTML_TEMPLATE%html

        self.site_cache[link] = html
        self.current_url = link#document.resolve_uri(link)

        document.open_stream('text/html')
        document.write_stream(html)
        document.close_stream()
        gobject.idle_add(self.view.set_document,document)




class ListenLyrics(gtk.VBox):
    def __init__(self,media_organizer):
        gtk.VBox.__init__(self,False,0)
        self.media_organizer = media_organizer

        self.song = None

        self.document_info = HTMLDocument()

        self.media_organizer.player.gst_player.connect("new-media",self.new_media_cb)

        HTML_PRESENTATION = HTML_TEMPLATE%("")

        self.document_info.clear()
        self.document_info.open_stream('text/html')
        self.document_info.write_stream(HTML_PRESENTATION)
        self.document_info.close_stream()


        self.view = gtkhtml2.View()
        self.view.set_document(self.document_info)
        self.view.set_magnification(1)


        self.pack_start(get_scrolled_window(self.view))

    def new_media_cb(self,widget,song):
        self.song = song
        self.set_html("<h3>"+_("Fetching lyrics for")+" <b>"+song.sprint("title")+"</b></h3>")
        thread = threading.Thread(target=self.fetch_lyrics)
        thread.setDaemon(True)
        thread.start()


    def fetch_lyrics(self):

        artist = self.song.sprint("artist").encode("utf-8")
        title = self.song.sprint("title").encode("utf-8")
        self.songlist = []
        try:
            sock = urllib.urlopen(
                "http://api.leoslyrics.com/api_search.php?auth="
                "QuodLibet&artist=%s&songtitle=%s"%(
                urllib.quote(artist.encode('utf-8')),
                urllib.quote(title.encode('utf-8'))))
            xmldoc = minidom.parse(sock).documentElement
        except:
            gobject.idle_add(self.set_html, _("<p>Server did not respond.</p>"))
            return

        sock.close()
        result_code = xmldoc.getElementsByTagName(
            'response')[0].getAttribute('code')
        #print "Result code: ", result_code
        if result_code == '0': #success
            # This is 0 even if there are no matches.

            # We don't really need the top 100 matches, so I'm limiting it to ten
            matches = xmldoc.getElementsByTagName('result')[:10]
            songs = map(lambda x:
                        x.getElementsByTagName('name')[0].firstChild.nodeValue
            + " - " +
            x.getElementsByTagName('title')[0].firstChild.nodeValue,
            matches)
            hids = map(lambda x: x.getAttribute('hid'), matches)
            exacts = map(lambda x: x.getAttribute('exactMatch'), matches)
            #print "->>"
            #print hids
            #print exacts
            if len(hids) == 0:
                #FIXME show other matches
                gobject.idle_add(self.set_html, '<p>Unable to find any ' +
                                 'matches for this song.</p>')
                return

            for i in range(len(hids)):
                self.songlist.append((songs[i], hids[i], exacts[i]))

            xmldoc.unlink()

            # Show the first match
            try:
                sock = urllib.urlopen(
                    "http://api.leoslyrics.com/api_lyrics.php?auth="
                    "QuodLibet&hid=%s"%(
                    urllib.quote(self.songlist[0][1].encode('utf-8'))))
                xmldoc = minidom.parse(sock).documentElement
            except:
                gobject.idle_add(buffer.set_text,
                                 "<p>Unable to get the lyrics. " +
                                 "Please try again later.</p>")
                return
            sock.close()

            text = "<h1>"+xmldoc.getElementsByTagName('title')[0].firstChild.nodeValue
            text += ' - ' + xmldoc.getElementsByTagName('artist')[0].getElementsByTagName('name')[0].firstChild.nodeValue +"</h1>"
            text += "<p>&nbsp;</p><p>"+xmldoc.getElementsByTagName('text')[0].firstChild.nodeValue.replace("\n","</p><p>")+"</p>"
            xmldoc.unlink()

            text += "<p>&nbsp;</p><p><i>Lyrics provided by leoslyrics.com</i></p>"
            #print text
            gobject.idle_add(self.set_html, text)

        else: #failed
            gobject.idle_add(self.set_html, "<p>Server busy, try again later.</p>")
            xmldoc.unlink()
            return

    def set_html(self,html):
        self.document_info.clear()

        html = HTML_TEMPLATE%(html)

        self.document_info.open_stream('text/html')
        self.document_info.write_stream(html)
        self.document_info.close_stream()







