###
#
# Listen is the legal property of mehdi abaakouk <theli48@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###

import gtk
import sys


import config
from db_manager import DBManager
from misc_widget import WindowBase
from file_inspector import *

class ListenUI(gtk.Window):
    def __init__(self,player,media_organizer,osd):
        gtk.Window.__init__(self,gtk.WINDOW_TOPLEVEL)

        self.player = player;
        self.media_organizer = media_organizer
        self.osd = osd


        self.menu_items = (
            ( "/_File", None, None, 0, "<Branch>" ),
            ( "/File/Quit", "<control>Q", self.on_quit, 0, None ),
        )
        self.set_title("Listen")

        self.set_icon_from_file(config.PIXMAP_DIR+"listen.png")
        gtk.window_set_default_icon_from_file(config.PIXMAP_DIR+"listen.png")

        hbox1 = gtk.HBox()
        hbox1.pack_start(self.player,False,False)
        self.separateur = gtk.VSeparator()
        hbox1.pack_start(self.separateur,False,False)
        hbox1.pack_start(self.media_organizer,True,True)
        hbox1.set_spacing(12)
        hbox1.set_border_width(6)
        vbox1 = gtk.VBox()
        vbox1.pack_start(self.get_main_menu(),False,False)
        vbox1.pack_start(hbox1,True,True)

        self.add(vbox1)

        #self.connect("delete-event",self.on_quit)

        self.drag_dest_set(0, [],0)
        """self.enable_model_drag_dest([("text/uri-list", 0, 0)], gtk.gdk.ACTION_COPY)
        self.enable_model_drag_source(
            gtk.gdk.BUTTON1_MASK|gtk.gdk.SHIFT_MASK|gtk.gdk.CONTROL_MASK, [("text/uri-list", 0, 0)],
            gtk.gdk.ACTION_COPY)
        """
        """self.connect('drag_drop', self.__window_drag_drop)
        self.connect('drag_motion', self.__window_drag_motion)
        self.connect("drag_data_received", self.__window_drag_data_received)
        """

        window_state = config.get("setting","window_state")
        if window_state == "maximized" :
            self.maximize()
        if window_state == "normal":
            self.unmaximize()

        if config.get("setting","start_trayicon")=="true":
            self.set_no_show_all(True)
            self.hide_all()


        if config.get("setting","pos_x")=="-1":
            self.set_position(gtk.WIN_POS_CENTER)
        else:
            self.move(int(config.get("setting","pos_x")),int(config.get("setting","pos_y")))


        if config.get("setting","media_organizer")=="false":
            self.set_geometry_hints(self, min_width=-1, min_height=-1, max_width=312, max_height=100000,
                                    base_width=-1, base_height=-1, width_inc=-1, height_inc=-1,
                                    min_aspect=-1.0, max_aspect=-1.0)
            self.player.btn_media_organizer.set_property("active",False)
            self.media_organizer.hide()
            self.separateur.hide()
        else:
            self.set_geometry_hints(self, min_width=-1, min_height=-1, max_width=-1, max_height=-1,
                                    base_width=-1, base_height=-1, width_inc=-1, height_inc=-1,
                                    min_aspect=-1.0, max_aspect=-1.0)
            self.media_organizer.show_all()
            self.separateur.show_all()
            self.player.btn_media_organizer.set_property("active",True)

        try: self.resize(int(config.get("setting","width")),int(config.get("setting","height")))
        except:pass
        self.player.btn_media_organizer.connect("clicked",self.show_hide_Library)
        self.media_organizer.set_no_show_all(True)
        self.separateur.set_no_show_all(True)




    def on_quit(self,widget=None,event=None):
        #On arrete le transfert de l'ipod
        #FIXME: change to implement new source interface
        #if self.media_organizer.ipod_transfert_manager.ipod_is_in_transfer:
        #    self.media_organizer.ipod_transfert_manager.cancel_tranfert(None)


        self.player.time_box.stop()
        self.player.gst_player.stop()
        self.player.playlist.save_to_db();

        self.media_organizer.save_config()

        #windows property
        width, height = self.get_size()
        config.set("setting","width","%d"%width)
        config.set("setting","height","%d"%height)
        pos_x, pos_y = self.get_position()
        config.set("setting","pos_x","%d"%pos_x)
        config.set("setting","pos_y","%d"%pos_y)


        DBManager.close()
        config.write(config.CONFIG_FILE)
        gtk.main_quit()
        print "Listen exit"
        sys.exit(0)


    def show_hide_Library(self,btn):
        self.media_organizer.set_no_show_all(False)
        self.separateur.set_no_show_all(False)
        if self.media_organizer.get_property('visible'):
            self.media_organizer.hide()
            self.separateur.hide()
            #On crontruit quand meme le contenu
            self.set_geometry_hints(self, min_width=-1, min_height=-1, max_width=312, max_height=100000,
                                    base_width=-1, base_height=-1, width_inc=-1, height_inc=-1,
                                    min_aspect=-1.0, max_aspect=-1.0)
            self.media_organizer.realize()
            self.separateur.realize()
        else:
            self.set_geometry_hints(self, min_width=-1, min_height=-1, max_width=-1, max_height=-1,
                                    base_width=-1, base_height=-1, width_inc=-1, height_inc=-1,
                                    min_aspect=-1.0, max_aspect=-1.0)
            self.media_organizer.show_all()
            self.separateur.show_all()
        self.media_organizer.set_no_show_all(True)
        self.separateur.set_no_show_all(True)
        #on rend le resultat
        while gtk.events_pending():gtk.main_iteration()

    def about_dialog(self,btn):
        about = gtk.AboutDialog()
        about.set_comments("""A music player for GNOME
        Written by Mehdi Abaakouk <theli48@gmail.com>""")
        about.set_website("http://listengnome.free.fr")
        about.set_name("Listen Music Player")
        #about.set_authors("Mehdi Abaakouk <theli48@gmail.com>")
        about.set_version(config.VERSION)
        about.set_logo(gtk.gdk.pixbuf_new_from_file(config.PIXMAP_DIR+"listen_big.png"))
        about.show_all()

    def __window_drag_motion(self, widget, context, x, y, time):
        context.drag_status(gtk.gdk.ACTION_COPY, time)
        return True

    def __window_drag_drop(self, widget, context, x, y, time):
        widget.drag_get_data(context, 'text/uri-list', time)
        return True

    def __window_drag_data_received(self, widget, context, x, y, selection, targetType, timestamp):
        #Vient de l exterieur
        if context.get_source_widget()==None:
          for uri in selection.get_uris():
             uri = urllib.unquote(uri)
             print uri
             self.player.playlist.add(uri)



    def add_radio(self,btn):
        dialog = WindowBase(
                         _("Add a radio to the media library"),
                         config.PIXMAP_DIR+"playlist_radio_big.png"
                    )
        dialog.set_property("skip-taskbar-hint",True)
        dialog.set_property('has-separator',True)
        entry_title = gtk.Entry()
        entry_uri = gtk.Entry()
        label_title = gtk.Label(_("Name")+" : ")
        label_uri = gtk.Label(_("Uri")+" : ")

        table = gtk.Table(rows=6, columns=2, homogeneous=False)
        table.set_row_spacings(3)
        table.set_col_spacing(1,6)

        table.attach(label_title,0,1,0,1,gtk.FILL,gtk.FILL)
        table.attach(entry_title,1,2,0,1,gtk.EXPAND|gtk.FILL,gtk.SHRINK)

        table.attach(label_uri,0,1,1,2,gtk.FILL,gtk.FILL)
        table.attach(entry_uri,1,2,1,2,gtk.EXPAND|gtk.FILL,gtk.SHRINK)


        dialog.add_widget(table)
        dialog.show_all()
        response = dialog.run()

        def add_iradio_in_db(uri,name):
            #FIXME: Add verification stream exist
            if utils.get_ext(uri) in PLAYLIST_EXTENTION:
                i = 0
                #FIXME : autodetect playlist type no always use m3u
                new_name= name
                for new_uri in utils.import_playlist(uri,".m3u"):
                    song = DBManager.get_iradio_by_uri(new_uri)
                    if song!=None:
                       song.set_property("title",new_name)
                       DBManager.update_song(song)
                       new_name = name+" (%d)"%i
                       i += 1
            else:
                song = DBManager.get_iradio_by_uri(uri);
                if song!=None:
                   song.set_property("title",name)
                   DBManager.update_song(song)

        if response == gtk.RESPONSE_ACCEPT and entry_uri.get_text() != "":
            add_iradio_in_db(entry_uri.get_text(),entry_title.get_text())
            dialog.destroy()
        else:
           dialog.destroy()

    def add_directory(self,btn):
        dialog = gtk.FileChooserDialog(_("Choose directory to add the library"), None,
             gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER,
             (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN, gtk.RESPONSE_OK))


        dialog.set_current_folder(os.path.expanduser("~/"))
        file = ''
        response = dialog.run()
        if response == gtk.RESPONSE_OK:
             file = dialog.get_filename()
             dialog.destroy()
             if os.path.exists(file):
                print file
                dialog_wait = WindowBase(
                                 _("Add a directory in library"),
                                 config.PIXMAP_DIR+"listen.png",
                                 None
                                )
                dialog_wait.connect("delete-event",lambda *args:  True)
                dialog_wait.set_property("skip-taskbar-hint",True)
                dialog_wait.set_property('has-separator',False)
                progress_bar = gtk.ProgressBar()
                box = gtk.HBox()
                box.pack_start(progress_bar,True,True,12)
                label = gtk.Label(_("Reading directory..."))
                label.set_alignment(0,0.5)
                dialog_wait.add_widget(label)
                dialog_wait.vbox.pack_start(box,True,True)
                dialog_wait.show_all()
                progress_bar.set_size_request(344,-1)
                while gtk.events_pending(): gtk.main_iteration()
                file_inspector = ListenFileInspector()
                gobject.idle_add(file_inspector.parse_directory,file)
                gobject.timeout_add(100,self.check_directory,file_inspector,dialog_wait,label,progress_bar)

        else:
            dialog.destroy()

    def refresh_db(self,btn):
        dialog_wait = WindowBase(
                         _("Refresh the library"),
                         config.PIXMAP_DIR+"listen.png",
                         None
                        )
        dialog_wait.connect("delete-event",lambda *args:  True)
        dialog_wait.set_property("skip-taskbar-hint",True)
        dialog_wait.set_property('has-separator',False)
        progress_bar = gtk.ProgressBar()
        box = gtk.HBox()
        box.pack_start(progress_bar,True,True,12)
        label = gtk.Label(_("Reading library..."))
        label.set_alignment(0,0.5)
        dialog_wait.add_widget(label)
        dialog_wait.vbox.pack_start(box,True,True)
        dialog_wait.show_all()
        progress_bar.set_size_request(344,-1)
        while gtk.events_pending(): gtk.main_iteration()
        file_inspector = ListenFileInspector()
        gobject.idle_add(file_inspector.check_db)
        gobject.timeout_add(100,self.refresh_db_cb,file_inspector,dialog_wait,label,progress_bar)


    def refresh_db_cb(self,file_inspector,dialog_wait,label,progress_bar):
        progress_bar.pulse()
        if file_inspector.is_ready() == False:
            return True
        info = file_inspector.get_info()
        if info == None:
            from media_source import ListenMLBrowserSource
            for source in self.media_organizer.list_source:
                if isinstance(source,ListenMLBrowserSource):
                    source.widget.refresh_cache()
                    source.widget.populate_view()

            del file_inspector
            dialog_wait.destroy()
            return False
        else:
            file = info["file"]
            fraction = round(round(info["num"]) / info["total"],2)
            #print info["num"],"/",info["total"],"=",info["num"] / info["total"],"=>",fraction
            progress_bar.set_fraction(fraction)
            progress_bar.set_text("%d/%d"%(info["num"],info["total"]))
            #replace with pango.elispze
            if len(file)>37:
                file = '...'+file[len(file)-37:]
            label.set_text(file)
            while gtk.events_pending(): gtk.main_iteration()
            return True

    def check_directory(self,file_inspector,dialog_wait,label,progress_bar):
        progress_bar.pulse()
        if file_inspector.is_ready() == False:
            return True
        info = file_inspector.get_info()
        if info == None:
            from media_source import ListenMLBrowserSource
            for source in self.media_organizer.list_source:
                if isinstance(source,ListenMLBrowserSource):
                    source.widget.refresh_cache()
                    source.widget.populate_view()
            del file_inspector
            dialog_wait.destroy()
            return False
        else:
            file = info["file"]
            fraction = round(round(info["num"]) / info["total"],2)

            progress_bar.set_fraction(fraction)
            progress_bar.set_text("%d/%d"%(info["num"],info["total"]))
            if len(file)>37:
                file = '...'+file[len(file)-37:]
            label.set_text(file)
            while gtk.events_pending(): gtk.main_iteration()
            return True


    def add_file(self,btn):
        dialog = gtk.FileChooserDialog(_("Choose file to add in library"), None,
             gtk.FILE_CHOOSER_ACTION_OPEN,
             (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN, gtk.RESPONSE_OK))


        dialog.set_current_folder(os.path.expanduser("~/"))
        file = ''
        response = dialog.run()
        if response == gtk.RESPONSE_OK:
           file = dialog.get_filename()
           dialog.destroy()
           song = DBManager.get_song_by_uri("file://"+file)
        else:
            dialog.destroy()


    def add_uri(self,btn):
        print "open"


    def show_preferences(self,btn):
        dialog_pref = WindowBase(_("Preferences"),config.PIXMAP_DIR+"/gnome-settings.png",(gtk.STOCK_SAVE, gtk.RESPONSE_APPLY,gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL)     )
        label1 = gtk.Label("<b>"+_("General")+"</b>")
        label1.set_use_markup(True)
        label1.set_alignment(0,0.5)
        check_splash = gtk.CheckButton(_("Show splashscreen"))
        check_start_minimize = gtk.CheckButton(_("Start minimized"))
        check_use_trayicon = gtk.CheckButton(_("Enable trayicon"))
        check_minimize_trayicon = gtk.CheckButton(_("Minimized to systray"))
        check_close_to_trayicon = gtk.CheckButton(_("Close to systray"))
        check_random = gtk.CheckButton(_("Play a random file when playlist is empty"))
        if config.get("setting","splash")=="true":
            check_splash.set_property("active",True)
        if config.get("setting","start_trayicon")=="true":
            check_start_minimize.set_property("active",True)
        if config.get("setting","use_trayicon")=="true":
            check_use_trayicon.set_property("active",True)
        if config.get("setting","reduire_trayicon")=="true":
            check_minimize_trayicon.set_property("active",True)
        if config.get("setting","fermer_trayicon")=="true":
            check_close_to_trayicon.set_property("active",True)
        if config.get("setting","empty_random")=="true":
            check_random.set_property("active",True)

        vbox1 = gtk.VBox(False)
        #vbox1.pack_start(label1)
        vbox1.pack_start(check_splash,False,False)
        vbox1.pack_start(check_start_minimize,False,False)
        vbox1.pack_start(check_use_trayicon,False,False)
        vbox1.pack_start(check_minimize_trayicon,False,False)
        vbox1.pack_start(check_close_to_trayicon,False,False)
        vbox1.pack_start(check_random,False,False)

        dialog_pref.add_widget(vbox1)
        dialog_pref.show_all()
        response = dialog_pref.run()

        if response == gtk.RESPONSE_APPLY:
            if check_splash.get_property("active"):
                config.set("setting","splash","true")
            else:
                config.set("setting","splash","false")

            if check_start_minimize.get_property("active"):
                config.set("setting","start_trayicon","true")
            else:
                config.set("setting","start_trayicon","false")

            if check_use_trayicon.get_property("active"):
                config.set("setting","use_trayicon","true")
            else:
                config.set("setting","use_trayicon","false")

            if check_minimize_trayicon.get_property("active"):
                config.set("setting","reduire_trayicon","true")
            else:
                config.set("setting","reduire_trayicon","false")

            if check_close_to_trayicon.get_property("active"):
                config.set("setting","fermer_trayicon","true")
            else:
                config.set("setting","fermer_trayicon","false")

            if check_random.get_property("active"):
                config.set("setting","empty_random","true")
            else:
                config.set("setting","empty_random","false")
            config.write(config.CONFIG_FILE)

        dialog_pref.destroy()
        #dialog_pref.add_widget()

    def show_osd_pref(self,btn):
        osd_pref = self.osd.PluginPreferences(self)
        osd_pref.show_all()

    def get_main_menu(self):
        menu = """
        <ui>
          <menubar name="MenuBar">
            <menu action="File">
              <menuitem action="AddFile"/>
              <menuitem action="AddPath"/>
              <menuitem action="AddRadio"/>
              <separator />
              <menuitem action="Refresh"/>
              <separator />
              <menuitem action="Config"/>
              <menuitem action="ConfigOSD"/>
              <separator />
              <menuitem action="Quit"/>
            </menu>
            <menu action="Help">
              <menuitem action="About"/>
            </menu>
          </menubar>
        </ui>
        """
        """
              <menuitem action="AddUri"/>
            <menu action="View">
              <menuitem action="Library"/>
            </menu>
        """
        self.uimanager = gtk.UIManager()
        self.uimanager.add_ui_from_string(menu)
        accelgroup = self.uimanager.get_accel_group()

        # Create the base ActionGroup
        actiongroup0 = gtk.ActionGroup('Listen')

        actiongroup0.add_actions([('File', None, _('_File')),
                                  ('Help', None, _('_Help'))])
        self.uimanager.insert_action_group(actiongroup0, 0)

        actiongroup = gtk.ActionGroup('Listen')
        self.actiongroup = actiongroup
        # Create a ToggleAction, etc.

        #actiongroup.add_toggle_actions([('Library', None, 'Show _Library', None,
        #                                 'Show/Hide Library', self.show_hide_Library,True)])
        #actiongroup.add_actions([('AddUri', gtk.STOCK_ADD, _('Add a _uri'), None,
        #                                 _('Open a uri'), self.add_uri)])

        actiongroup.add_actions([('AddFile', gtk.STOCK_ADD, _('Import a _file '), None,
                                         _('Import a file in library'), self.add_file)])
        actiongroup.add_actions([('AddPath', gtk.STOCK_ADD, _('Import a _directory'), None,
                                         _('Import a directory'), self.add_directory)])
        actiongroup.add_actions([('AddRadio', gtk.STOCK_ADD, _('Add a _radio'), None,
                                         _('Import a radio'), self.add_radio)])
        actiongroup.add_actions([('Refresh', gtk.STOCK_REFRESH, _('Refresh Library'), None,
                                         _('Refresh Library'), self.refresh_db)])

        actiongroup.add_actions([('About', gtk.STOCK_ABOUT, _('_About'), None,
                                         _('About Listen'), self.about_dialog)])

        actiongroup.add_actions([('Config', gtk.STOCK_PREFERENCES, _('_Preferences'), None,
                          _('Preferences'), self.show_preferences)])
        actiongroup.add_actions([('ConfigOSD', gtk.STOCK_PREFERENCES, _('_OSD Preferences'), None,
                          _('OSD Preferences'), self.show_osd_pref)])

        actiongroup.add_actions([('Quit', gtk.STOCK_QUIT, _('_Quit'), None,
                          _('Quit Listen'), self.on_quit)])

        self.uimanager.insert_action_group(actiongroup, 1)

        self.add_accel_group(accelgroup)
        return self.uimanager.get_widget("/MenuBar")



