###
#
# Listen is the legal property of mehdi abaakouk <theli48@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###


import os, sys
import gtk
import gobject
import pango
import gnome
import gnome.ui
gnome.init("listen", "version")

import config
import stock
import utils
from misc_widget import VolumeSlider
from view_playlist_current import *
from song import Song
from misc_widget import AmazonWindow
from gstplayer import *



class ListenUIPlayer(gtk.VBox):
    __gsignals__ = {
        "player-action" : (gobject.SIGNAL_RUN_LAST,
                gobject.TYPE_NONE,
                (gobject.TYPE_STRING,))
    }
    def __init__(self,osd):
        self.osd = osd
        self.gst_player = GstPlayer(self)


        gtk.VBox.__init__(self)

        #self.gst_player.connect("play-end",self.__playlist_next_cb)

        self.btn_previous = gtk.Button()
        self.btn_previous.add(gtk.image_new_from_stock(gtk.STOCK_MEDIA_PREVIOUS, gtk.ICON_SIZE_LARGE_TOOLBAR))
        self.btn_previous.connect("clicked",self.__playlist_action,"previous")

        self.btn_next = gtk.Button()
        self.btn_next.add(gtk.image_new_from_stock(gtk.STOCK_MEDIA_NEXT, gtk.ICON_SIZE_LARGE_TOOLBAR))
        self.btn_next.connect("clicked",self.__playlist_action,"next")

        self.btn_play = gtk.ToggleButton()
        self.btn_play.add(gtk.image_new_from_stock(gtk.STOCK_MEDIA_PLAY, gtk.ICON_SIZE_LARGE_TOOLBAR))
        self.btn_play.connect("clicked",self.__playlist_action,"play")

        self.btn_media_organizer = gtk.ToggleButton(_("Library"))
        #self.btn_media_organizer = gtk.ToggleButton()
        if config.get("setting","media_organizer")=="false":
            self.btn_media_organizer.set_active(False)
        else:
            self.btn_media_organizer.set_active(True)
            """
        box_btn_media_organizer = gtk.HBox(False)
        box_btn_media_organizer.pack_start(gtk.image_new_from_stock(stock.MEDIA_LIB, gtk.ICON_SIZE_LARGE_TOOLBAR))
        box_btn_media_organizer.pack_start(gtk.Label(_("Library")))

        self.btn_media_organizer.add(box_btn_media_organizer)"""

        self.btn_media_organizer.set_image(gtk.image_new_from_stock(stock.MEDIA_LIB, gtk.ICON_SIZE_LARGE_TOOLBAR))
        #self.btn_media_organizer.set_size_request(100,-1)



        self.btn_volume = VolumeSlider(self.gst_player)

        self.time_box = ListenUISongTime(self.gst_player)

        hbox_btn = gtk.HBox()
        hbox_btn.set_spacing(6)
        hbox_btn.pack_start(self.btn_previous,False,False)
        hbox_btn.pack_start(self.btn_play,False,False)
        hbox_btn.pack_start(self.btn_next,False,False)
        hbox_btn.pack_start(self.btn_volume,False,False)
        hbox_btn.pack_end(self.btn_media_organizer,False,False)

        self.song_information = gtk.Label("");#"<b><i>Stopped</i></b>");#"<b>Title</b>\n<i>Artist</i>\nAlbum")
        self.song_information.set_property("ellipsize",pango.ELLIPSIZE_END)
        self.current_info = {}
        self.song_information.set_use_markup(True)
        self.song_information.set_alignment(0,0.1)
        self.album_art = gtk.image_new_from_stock(stock.ALBUM_ART, gtk.icon_size_register("album_art", 75, 75))
        #tooltips = gtk.Tooltips()
        #tooltips.set_tip(self.album_art,_("Clic to change album cover"))
        self.album_art.set_size_request(75,75)
        self.album_art.set_alignment(0.5,0.5)

        self.btn_album_art = gtk.Button()
        self.btn_album_art.set_alignment(0.5,0.5)
        self.btn_album_art.connect("clicked",self.on_change_album_art)
        self.btn_album_art.set_relief(gtk.RELIEF_NONE)
        self.btn_album_art.add(self.album_art)


        hbox_info2 = gtk.VBox()
        hbox_info2.pack_start(self.song_information,True,True)
        hbox_info2.pack_start(self.time_box,False,False)
        self.hbox_info = gtk.HBox()
        self.hbox_info.pack_start(self.btn_album_art,False,False)
        self.hbox_info.pack_start(hbox_info2,True,True)
        self.hbox_info.set_spacing(6)


        self.label_playlist = gtk.Label("<b>"+_("Playlist")+"</b>")
        self.label_playlist.set_use_markup(True)
        self.label_playlist.set_alignment(0,1)

        vbox1 = gtk.VBox()
        vbox1.pack_start(hbox_btn,False,False)
        vbox1.pack_start(self.hbox_info,False,False)
        #vbox1.pack_start(gtk.HSeparator(),False,False)
        #vbox1.pack_start(self.time_box,False,False)
        vbox1.pack_start(self.label_playlist,False,False)
        vbox1.set_spacing(12)





        self.btn_save= gtk.Button()
        self.btn_save.add(gtk.image_new_from_stock(gtk.STOCK_SAVE, gtk.ICON_SIZE_LARGE_TOOLBAR))
        self.btn_save.set_size_request(36,-1)

        self.btn_burn = gtk.Button()
        self.btn_burn.add(gtk.image_new_from_stock(gtk.STOCK_CDROM, gtk.ICON_SIZE_LARGE_TOOLBAR))
        self.btn_burn.set_size_request(36,-1)

        self.btn_clear = gtk.Button()
        self.btn_clear.add(gtk.image_new_from_stock(gtk.STOCK_CLEAR, gtk.ICON_SIZE_LARGE_TOOLBAR))
        self.btn_clear.set_size_request(36,-1)

        self.btn_shuffle = gtk.Button()
        self.btn_shuffle.add(gtk.image_new_from_icon_name("stock_shuffle", gtk.ICON_SIZE_LARGE_TOOLBAR))
        self.btn_shuffle.set_size_request(36,-1)
        #self.btn_shuffle.add(gtk.image_new_from_icon_name("stock_shuffle", gtk.ICON_SIZE_LARGE_TOOLBAR))

        self.btn_repeat = gtk.ToggleButton()
        self.btn_repeat.set_size_request(36,-1)
        #self.btn_repeat.add(gtk.image_new_from_stock(stock.REPEAT, gtk.ICON_SIZE_LARGE_TOOLBAR))
        self.btn_repeat.add(gtk.image_new_from_icon_name("stock_repeat", gtk.ICON_SIZE_LARGE_TOOLBAR))
        if config.get("setting","repeat_mode")=="true":
            self.btn_repeat.set_property("active",True)

        self.playlist_total_time = gtk.Label("")
        self.playlist_total_time.set_alignment(1,0.5)
        hbox3 = gtk.HBox()
        hbox3.pack_start(self.btn_save,False,False)
        hbox3.pack_start(self.btn_burn,False,False)
        hbox3.pack_start(self.btn_clear,False,False)
        hbox3.pack_start(self.btn_shuffle,False,False)
        hbox3.pack_start(self.btn_repeat,False,False)
        hbox3.pack_start(self.playlist_total_time)
        #hbox3.pack_start(self.btn_media_organizer,False,False)

        self.playlist = ListenUIPlaylist(self)
        self.btn_clear.connect("clicked",self.playlist.clear)
        self.btn_burn.connect("clicked",self.burn)
        self.btn_save.connect("clicked",self.playlist.save_current_playlist)
        self.btn_shuffle.connect("clicked",self.playlist.shuffle)
        self.btn_repeat.connect("clicked",self.playlist.repeat)

        scroll = gtk.ScrolledWindow()
        scroll.add(self.playlist)
        scroll.set_shadow_type(gtk.SHADOW_IN)
        scroll.set_policy(gtk.POLICY_NEVER,gtk.POLICY_AUTOMATIC)
        scroll.set_size_request(-1,300)


        self.pack_start(vbox1,False,False)
        #self.pack_start(label_playlist,False,False)
        self.pack_start(scroll,True,True)
        self.pack_start(hbox3,False,False)
        self.set_spacing(6)
        self.set_size_request(300,-1)


        self.keys = MmKeys({"mm_prev": self.__mm_previous,
                              "mm_next": self.__mm_next,
                              "mm_playpause": self.__mm_play})

        self.playlist.connect("playlist-changed",self.on_playlist_changed_cb)

        self.last_osd_verif_no_change_string = "";
        self.last_art=None
        self.current_info = None



    def __mm_previous(self,a,b):
        self.btn_previous.emit("clicked")
    def __mm_next(self,a,b):
        self.btn_next.emit("clicked")
    def __mm_play(self,a,b):
        self.btn_play.emit("clicked")


    def burn(self,btn=None):
        list_song = []
        for row in self.playlist.model:
            list_song.append(row[0])
        utils.export_playlist("/tmp/listen_burn_list.m3u",list_song)

        dialog = WindowBase(_("Would you like burn this playlist ?"),config.PIXMAP_DIR+"playlist_burn.png",None)

        dialog.add_button(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL)

        btn_pref = gtk.Button(gtk.STOCK_PREFERENCES)
        btn_pref.set_use_stock(True)
        dialog.add_action_widget(btn_pref,gtk.RESPONSE_NONE)

        btn_burn = gtk.Button(_("Burn"))
        btn_burn.set_image(gtk.image_new_from_stock(gtk.STOCK_CDROM, gtk.ICON_SIZE_LARGE_TOOLBAR))
        dialog.add_action_widget(btn_burn,gtk.RESPONSE_OK)

        label = gtk.Label(_("Tips : For more option configure serpentine"))
        label.set_alignment(0,0.5)

        dialog.add_widget(label)
        dialog.show_all()
        res = gtk.RESPONSE_NONE
        while res == gtk.RESPONSE_NONE:
            res = dialog.run()
            if res == gtk.RESPONSE_NONE:
                os.spawnlp(os.P_NOWAIT, "serpentine","serpentine","--preferences")

        if res == gtk.RESPONSE_OK:
            os.spawnlp(os.P_NOWAIT, "serpentine","serpentine","-w","/tmp/listen_burn_list.m3u")

        dialog.destroy()


    """ def __playlist_next_cb(self,widget,property):
        while gtk.events_pending():gtk.main_iteration()
        print "cb ok"
        self.__playlist_action(None, "next")"""

    def playlist_next_cb(self):
        self.__playlist_action(None, "next")

    def __playlist_action(self,btn, action):

        if action == "play":
            if not self.btn_play.get_active():
                res = "pause"
                self.gst_player.pause()
                self.pause()
            else:
                if not self.gst_player.is_playable():
                    res = "play"
                    self.play(self.playlist.get_next_song())
                elif len(self.playlist.model)!=0 or self.gst_player.is_playable():
                    self.play()
                    res = "play"
                else:
                    self.pause()
                    return

        if action == "next":
            res = "next"
            song = self.playlist.get_next_song()
            if song!=None:
                self.play(song)
            else:
                self.pause()
                return

        if action == "previous":
            res = "previous"
            song = self.playlist.get_previous_song()
            if song!=None:
                self.play(song)
            else:
                self.pause()
                return

        self.emit("player-action",res)

    def pause(self):
        self.btn_play.set_property('active',False)
        self.btn_play.child.set_from_stock(gtk.STOCK_MEDIA_PLAY,gtk.ICON_SIZE_LARGE_TOOLBAR)

    def play(self,song=None):
        if song!=None:
            self.gst_player.play_new(song)
            gobject.idle_add(self.update_metadata_db,song)
        else:
            self.gst_player.play()
        self.btn_play.set_property('active',True)
        self.btn_play.child.set_from_stock(gtk.STOCK_MEDIA_PAUSE,gtk.ICON_SIZE_LARGE_TOOLBAR)


    def update_metadata_db(self,song):
        if song!=None:
            song.update_play_information()
            #Check song is in DB
            if song.id!=None:
                DBManager.update_song(song,["playcount","last_played"])




    def on_playlist_changed_cb(self,widget,info):
        gobject.idle_add(self.on_playlist_changed,info)

    def on_playlist_changed(self,song):

        if song.is_stream:
            self.time_box.hide()
        else:
            self.time_box.show()

        self.time_box.set_duration(song.get_property("duration"))
        self.current_info = song

        sep="\n"
        sep_title=" - "

        osd_verif_no_change_string= ""
        text=""
        title=""
        art=""
        osd_verif_no_change_string= ""

        title = song.sprint("title")
        text += "<span size=\"x-large\"><b>"+song.sprint("title")+"</b></span>"

        if song.sprint("artist")!="":
            text += sep+"<i>"+song.sprint("artist")+"</i>"
            title += sep_title+song.sprint("artist")

        if song.sprint("album")!="":
            text += sep+song.sprint("album")
            title += sep_title+song.sprint("album")

        """if meta_dict.has_key("channel"):
            text += sep+"<i>"+xml.sax.saxutils.escape(meta_dict["channel"])+"</i>"
            title += sep_title+xml.sax.saxutils.escape(meta_dict["channel"])"""

        """# overwrite data if current song is a stream
        if meta_dict.has_key("channel") and meta_dict.has_key("title") and meta_dict["title"]:
            art=meta_dict["title"]"""

        #Write current sont information in fle for gaim 2.0 :)
        filename = os.path.join(os.path.expanduser("~"),".current-song")
        fileout = open(filename, "w")
        fileout.write(title)

        gobject.idle_add(self.add_image_album,song)

        title = "Listen  "+"\xe2\x99\xaa "+title+" "+" \xe2\x99\xaa "
        self.window.set_title(title)
        self.song_information.set_label(text)

    def on_change_album_art(self,btn):
        if self.current_info==None:
            return
        song = Song()
        song.read_from_song(self.current_info)
        if song.tagged:
            dialog = gtk.FileChooserDialog(_("Choose a album cover"), None,
                 gtk.FILE_CHOOSER_ACTION_OPEN,
                 (gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,gtk.STOCK_OPEN, gtk.RESPONSE_OK))

            btn = dialog.add_button(_("Internet search"),gtk.RESPONSE_HELP)
            btn.set_image(gtk.image_new_from_stock(gtk.STOCK_FIND, gtk.ICON_SIZE_LARGE_TOOLBAR))
            dialog.set_current_folder(os.path.expanduser("~/"))

            file = ''
            ffilter = gtk.FileFilter()
            ffilter.set_name(_("Image files"))
            ffilter.add_mime_type("image/bmp")
            ffilter.add_mime_type("image/gif")
            ffilter.add_mime_type("image/jpeg")
            ffilter.add_mime_type("image/png")
            ffilter.add_mime_type("image/svg+xml")

            dialog.add_filter(ffilter)
            dialog.set_size_request(500,350)

            response = dialog.run()
            if response == gtk.RESPONSE_OK:
                file = dialog.get_filename()
                pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(file,75,75)
                new_file = song.get_album_art_path()
                if os.path.exists(new_file):
                     os.unlink(new_file)
                pixbuf.save(new_file, "jpeg", {"quality":"85"})
                self.refresh_album_cover()
                del pixbuf
                dialog.destroy()
            elif response == gtk.RESPONSE_HELP:
                dialog.destroy()
                AmazonWindow(song)
                self.refresh_album_cover()
            else:
                dialog.destroy()

    def refresh_album_cover(self):
        filename = self.current_info.get_album_art()
        pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(filename,75,75)
        self.album_art.set_from_pixbuf(pixbuf)
        del pixbuf

    def add_image_album(self,song):
        filename = song.get_album_art()
        if config.get("osd","osd_enable")=="true":
            self.osd.show_osd(song,filename)
        pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(filename,75,75)
        self.album_art.set_from_pixbuf(pixbuf)
        del pixbuf


class ListenUISongTime(gtk.HBox):
    def __init__(self,gst_player):
        gtk.HBox.__init__(self,0,6)
        self.gst_player = gst_player
        self.label_time = gtk.Label("00:00 "+_("of")+" 00:00")
        self.label_time.set_alignment(0.2,0.5)

        self.bar_avancement = gtk.HScale()
        self.bar_avancement.set_draw_value(False)
        self.bar_avancement.set_range(0,1000)
        self.bar_avancement.set_value(0)
        self.bar_avancement.connect("button_press_event", self.on_bar_avancement_press_cb)
        self.bar_avancement.connect("button_release_event", self.on_bar_avancement_release_cb)
        #time_box = gtk.HBox(0,6)
        self.pack_start(self.label_time,False,False)
        self.pack_start(self.bar_avancement)
        self.update_bar_avancement = 1
        self.duration = 0
        self.delete = False
        gobject.timeout_add(1000, self.on_timeout)

    def stop(self):
        self.delete = True

    def set_duration(self,value):
        self.duration = value
        self.set_current_time(0)

    def on_timeout(self, *args):
        if self.update_bar_avancement == 1:
            pos = self.gst_player.get_position()
            if pos>=0:
                self.set_current_time(pos)
        return not self.delete

    def set_current_time(self,value):
        duration = self.duration
        #print duration
        if self.update_bar_avancement == 1:
            if duration==0:
                self.bar_avancement.set_range(0,1000)
                self.bar_avancement.set_value(1000)
            else :
                if value>=duration:
                    duration=value+1000
                self.bar_avancement.set_range(0,duration/1000)
                self.bar_avancement.set_value(value/1000)

        text  = "%d:%02d "%(value/60000, (value/1000)%60)+_("of")+" %d:%02d" % (duration/60000, (duration/1000)%60)
        self.label_time.set_label(text)

    def on_bar_avancement_press_cb(self,widget,event):
        self.update_bar_avancement = 0

    def on_bar_avancement_release_cb(self,widget,event):
        if self.gst_player.player.current_info.is_stream:
            self.update_bar_avancement = 1
            return
        value = self.bar_avancement.get_value()
        self.gst_player.seek(value*1000)
        self.update_bar_avancement = 1



class MmKeys(object):
    def __init__(self, cbs):
        self.__sigs = []
        try: import mmkeys
        except:
            class F(object):
                handler_block = handler_unblock = lambda s, a: False
            self.__keys = F()
        else:
            self.__keys = mmkeys.MmKeys()
            self.__sigs = map(self.__keys.connect, *zip(*cbs.items()))

    def block(self): map(self.__keys.handler_block, self.__sigs)
    def unblock(self): map(self.__keys.handler_unblock, self.__sigs)


