###
#
# Listen is the legal property of mehdi abaakouk <theli48@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###

import os
import mad
import ogg.vorbis
import gst
import gobject
import gtk
from time import time
import gst
import urllib
import amazon
try: import gpod
except: pass


import mutagen.id3
import utils
import config

"""DETECTION DES FORMATS SUPPORTER"""
READ_EXTENTIONS = []
BUILTIN_READ_EXTENTIONS = []
GST_READ_EXTENTIONS = []
WRITE_EXTENTIONS = []
PLAYLIST_EXTENTION = [".m3u",".pls"]

try: import mutagen.id3, mad
except ImportError: pass
else:
    BUILTIN_READ_EXTENTIONS.append(".mp3")
    BUILTIN_READ_EXTENTIONS.append(".mp2")
    WRITE_EXTENTIONS.append(".mp3")
    WRITE_EXTENTIONS.append(".mp2")
if gst.element_factory_make("mad"):
    GST_READ_EXTENTIONS.append(".mp3")
    GST_READ_EXTENTIONS.append(".mp2")

#from formats._vorbis import VCFile
try: import mutagen.flac
except ImportError: pass
else:
    BUILTIN_READ_EXTENTIONS.append(".flac")
    WRITE_EXTENTIONS.append(".flac")

if gst.element_factory_make('flacdec'):
    GST_READ_EXTENTIONS.append(".flac")


try: import ogg.vorbis
except ImportError: pass
else:
    BUILTIN_READ_EXTENTIONS.append(".ogg")
    WRITE_EXTENTIONS.append(".ogg")

if gst.element_factory_make('vorbisdec'):
    GST_READ_EXTENTIONS.append(".ogg")



try:
    import ctypes
    _mp4v2 = ctypes.cdll.LoadLibrary("libmp4v2.so.0")
    _mp4v2.MP4Read.restype = ctypes.c_void_p
    _mp4v2.MP4GetTrackType.restype = ctypes.c_char_p
    _mp4v2.MP4GetTrackDuration.restype = ctypes.c_uint64
    _mp4v2.MP4ConvertFromTrackDuration.restype = ctypes.c_uint64
    _mp4v2.MP4FindTrackId.restype = ctypes.c_uint32
    _mp4v2.MP4GetNumberOfTracks.restype = ctypes.c_uint32
except: pass
else:
    BUILTIN_READ_EXTENTIONS.append(".mp4")
    BUILTIN_READ_EXTENTIONS.append(".m4a")
if gst.element_factory_make("faad"):
    GST_READ_EXTENTIONS.append(".mp4")
    GST_READ_EXTENTIONS.append(".m4a")

try:
    import musepack
except ImportError: pass
else:
    BUILTIN_READ_EXTENTIONS.append(".mpc")
    BUILTIN_READ_EXTENTIONS.append(".mp+")

if gst.element_factory_make('musepackdec'):
    GST_READ_EXTENTIONS.append(".mpc")
    GST_READ_EXTENTIONS.append(".mp+")

if gst.element_factory_make('ffdec_wmav1') and gst.element_factory_make('ffdec_wmav2'):
    GST_READ_EXTENTIONS.append(".wma")

tmp = []
tmp2 = []
tmp3 = []
#Suppress builtin ext from gstreamer ext
#And remove read and write support if not gstreamer read
for i in range(0,len(GST_READ_EXTENTIONS)):
    if GST_READ_EXTENTIONS[i] not in BUILTIN_READ_EXTENTIONS:
        tmp.append(GST_READ_EXTENTIONS[i])
    else:
        tmp2.append(GST_READ_EXTENTIONS[i])
        if GST_READ_EXTENTIONS[i] in WRITE_EXTENTIONS:
            tmp3.append(GST_READ_EXTENTIONS[i])

GST_READ_EXTENTIONS = tmp
BUILTIN_READ_EXTENTIONS = tmp2
WRITE_EXTENTIONS = tmp3
del tmp
del tmp2
del tmp3

READ_EXTENTIONS.extend(BUILTIN_READ_EXTENTIONS)
READ_EXTENTIONS.extend(GST_READ_EXTENTIONS)

def get_supported_extention():
    string = "Extension support tag reading: \n"+str(READ_EXTENTIONS)
    string += "\n- with builtin reading (fast): \n"+str(BUILTIN_READ_EXTENTIONS)
    string += "\n- with gstreamer reading (slow): \n"+str(GST_READ_EXTENTIONS)
    string += "\nExtension support tag writting: \n"+str(WRITE_EXTENTIONS)
    return string

if False:
    print get_supported_extention()


#List of album cover that don't try to download the image
#beacause i already tried and it doesn't exist on amazon
SKIP_ALBUM_COVER = []
#this list was reinit all the 30min
def reinit_skip_album_cover():
    SKIP_ALBUM_COVER = []
REINIT_SKIP_ALBUM_COVER_TIME = 100*60*30
gobject.timeout_add(REINIT_SKIP_ALBUM_COVER_TIME,reinit_skip_album_cover)

class Song:
    def __init__(self):
        #gobject.GObject.__init__(self)

        self.id = None
        self.title = None
        self.artist = None
        self.album = None
        self.uri = None
        self.duration = None
        self.size = None
        self.tracknr = None
        self.bitrate = 0
        self.last_played = 0
        self.playcount = 0
        self.rate = 0
        self.is_stream = False

        #Obsolete must use isstream
        self.iradio = False

        self.ipod_track = None

        #FIXME remove ipod_id and use ipod_track.id
        self.ipod_id = None
        self.ipod_mount_point = None

        self.integer_key=["ipod_id","id","duration","size","tracknr","bitrate","last_played","rate","playcount"]

        self.last_error = ""
        self.tagged=False
        #self.local_media = False


    def get_dict(self):
        return {
                "id":self.id,
                "title":self.title,
                "artist":self.artist,
                "album":self.album,
                "uri":self.uri,
                "duration":self.duration,
                "size":self.size,
                "tracknr":self.tracknr,
                "rate":self.rate,
                "bitrate":self.bitrate,
                "last_played":self.last_played,
                "ipod_id":self.ipod_id,
                "ipod_mount_point":self.ipod_mount_point,
                "playcount":self.playcount,

                #Obsolete must use isstream
                "iradio":self.iradio,
                "is_stream":self.is_stream,
                "tagged":self.tagged
                 }
    def get_int(self,property):
        if property not in ["ipod_id","tracknr","id","duration"]:
            raise "get_int() not allowed for ",property
        else:
            value =  self.get_property(property)
            #Just a control ;)
            if value != None:
                assert(isinstance(value,int))
                return value
            else:
                return 0


    def set_property(self,property,value):

        if property=="ipod_track":
            self.ipod_track=value
        if property=="id":
            self.id=value
        if property=="title":
            self.title=value
        if property=="artist":
            self.artist=value
        if property=="album":
            self.album=value
        if property=="uri":
            self.uri=value
        if property=="ipod_mount_point":
            self.ipod_mount_point=value
        if property=="uri":
            self.uri=value
        if property=="iradio":
            if isinstance(value,bool):
                self.iradio=value
            else:
                self.iradio = bool(value)

        if property=="tracknr":
            if value==None or value=="":
                self.tracknr=None
            else:
                if not isinstance(value,int) and value.rfind("/")!=-1:
                    value = value[0:value.rfind("/")]
                self.tracknr=int(value)

        if property=="ipod_id":
            if value==None or value=="":
                self.ipod_id=None
            else:
                self.ipod_id=int(value)

        if value==None or value=="":
            value = "0"
        if property=="duration":
            self.duration=int(value)
        if property=="size":
            self.size=int(value)
        if property=="rate":
            self.rate=int(value)
        if property=="bitrate":
            self.bitrate=int(value)
        if property=="last_played":
            self.last_played=int(value)
        if property=="playcount":
            self.playcount=int(value)

    def get_property(self,property):
        value = self.get_dict()[property]
        """if property in self.integer_key:
            if value==None:
                value="0";
            return int(value)"""
        """if value==None:
            return """
        return value

    def read_from_song(self,song):
        self.read_from_dict(song.get_dict())
        self.tagged = song.tagged

    def read_from_dict(self,dict):
        for key,value in dict.iteritems():
            self.set_property(key,value)
        self.tagged = True

    def sprint(self,property):
        value = self.get_property(property)
        if property in ["ipod_track"]:
            return "???"

        if property=="tracknr" and value==None:
            value = ""
        if value==None:
            value = ""
        if isinstance(value,int):
            value = "%d"%value
        if property=="title" and value=="":
            value = self.get_filename()
        #print property, " - ",value
        return value

    """""""""""""""""""""
        FILE READER
    """""""""""""""""""""
    def read_from_file(self):
        if self.get_protocol()!="file://":
            self.last_error = self.get_protocol()+" "+_("Protocol not supported")
            return False
        if not os.path.exists(self.get_path()):
            self.last_error = self.get_filename()+_(" doesn't exist")
            return False
        if self.get_ext() not in READ_EXTENTIONS:
           self.last_error = self.get_filename()+_(": file formats don't support tag reading")
           return False
        if not os.access(self.get_path(),os.R_OK):
            self.last_error = self.get_filename()+_(" doesn't have enough permission")
            return False


        self.tagged=False
        if self.get_ext() not in BUILTIN_READ_EXTENTIONS:
            func = lambda:  self.read_from_gst_file()
        else:
            func = {
                '.mp3' : lambda: self.read_from_mp3_file(),
                '.mp2' : lambda: self.read_from_mp3_file(),
                '.ogg' : lambda:  self.read_from_ogg_file(),
                '.mp4' : lambda:  self.read_from_mp4_file(),
                '.m4a' : lambda:  self.read_from_mp4_file(),
                '.mpc' : lambda:  self.read_from_mpc_file(),
                '.mp+' : lambda:  self.read_from_mpc_file(),
                '.flac' : lambda:  self.read_from_flac_file()
            }[self.get_ext()]
        try: func()
        except Exception, inst:
            print "W: Error loading ("+self.get_path()+")\nTracback :",inst
            self.last_error = _("Error while reading")+": "+self.get_filename()
            return False
        else:
            self.tagged=True
            stats = os.stat(self.get_path())
            self.size = stats.st_size
            return True

    def read_from_gst_file(self):
        IDS = {
            "title": "title",
            "artist": "artist",
            "album": "album",
            "bitrate": "bitrate",
            'track-number':"tracknr"
        }
        def make_element(elementkind, elementname):
            factory = gst.element_factory_find(elementkind)
            if factory:
                return factory.create(elementname)
            else:
                return None

        def found_tag(decoder, source=None, taglist=None,arg=None):
            if taglist==None or not isinstance(taglist,gst.TagList):
                #taglist is a error string !!!
                #if minetype different TO extention
                self.stop_find_tag=True
                return False
            if not taglist.has_key('serial') and not self.tagged:#for first ogg tag
                self.tagged=True
                for key in taglist.keys():
                    if key=="bitrate":
                        value = int(taglist[key]/100)
                    elif isinstance(taglist[key],long):
                        value = int(taglist[key])
                    else:
                        value = taglist[key]
                    if key in IDS:
                        self.set_property(IDS[key],value)
                    #print key,": ",taglist[key]

        def add(element):
            assert self.pipeline.get_state() != gst.STATE_PLAYING
            elements = self.pipeline.get_list()
            self.pipeline.add(element)
            if elements and not elements[-1].link(element):
                raise "GSTREAMER No Link (BUG !?)"

        def on_error ( pipeline, element, error):
            self.stop_find_tag=True
            print error

        def on_eos (self):
            self.stop_find_tag=True

        self.pipeline = gst.parse_launch ("decodebin ! fakesink");
        # Last element of the bin is the sinks
        sink = self.pipeline.get_list ()[-1]

        filesrc = make_element("gnomevfssrc", "src")
        filesrc.set_property("location","file://"+urllib.quote(self.get_path()))#self.get_property("uri"))


        filesrc.link (self.pipeline.get_list ()[0])
        self.pipeline.add(filesrc)

        self.pipeline.connect("found-tag", found_tag)
        self.pipeline.connect("eos", found_tag)
        self.pipeline.connect("error", found_tag)

        self.pipeline.set_state(gst.STATE_PLAYING)

        progress = None
        total = 0
        pos = 0
        self.stop_find_tag = False
        while not ( self.stop_find_tag or (self.tagged and total!=0) ):#
             total = sink.query(gst.QUERY_TOTAL, gst.FORMAT_TIME)
             self.pipeline.iterate()

        total = sink.query(gst.QUERY_TOTAL, gst.FORMAT_TIME)
        total //= gst.MSECOND
        self.set_property("duration",int(total))

        self.pipeline.set_state(gst.STATE_NULL)
        del self.pipeline

        if self.tagged==True:
             return True
        else:
            #self.last_error=self.get_filename()+": an error occur while gstreamer decode tag"
            return False


    def read_from_mp3_file(self):
        IDS = {
            "TIT2": "title",
            "TPE1": "artist",
            "TALB": "album",
            "TRCK": "tracknr",
        }
        SDI = dict([(v, k) for k, v in IDS.iteritems()])
        try:
            tag = mutagen.id3.ID3(self.get_path())
        except mutagen.id3.error:
            tag = mutagen.id3.ID3()
            print "W: Error reading tag ("+self.get_path()+")"
            #raise mutagen.id3.ID3NoHeaderError

        for frame in tag.values():
            name = IDS.get(frame.FrameID, "").lower()
            if name != "":
                self.set_property(name,frame.text[0].encode("utf-8"))

        audio = mad.MadFile(self.get_path())
        if audio.total_time()>0:
            audio.seek_time(audio.total_time()/2)
            audio.read()
            bitrate = 0
            for i in range(5):
                bitrate += audio.bitrate()
                audio.read()
            audio.seek_time(audio.total_time()); audio.read()
            self.set_property("bitrate",bitrate/5)
            #print "%d"%audio.total_time()
            self.set_property("duration",audio.total_time())

    def read_from_flac_file(self):
        IDS = {
            "title": "title",
            "artist": "artist",
            "album": "album",
            "bitrate": "bitrate",
            'tracknumber':"tracknr"
        }

        f = mutagen.flac.FLAC(self.get_path())
        for key, value in f.vc.items():
            self.set_property(key,list(value)[0].encode("utf-8"))
        self.set_property("duration",int(f.info.length)*1000)

    def read_from_ogg_file(self):
        IDS = {
            "title": "title",
            "artist": "artist",
            "album": "album",
            "track": "tracknr",
        }
        SDI = dict([(v, k) for k, v in IDS.iteritems()])
        f = ogg.vorbis.VorbisFile(self.get_path())

        for key, value in f.comment().as_dict().iteritems():
            if IDS.has_key(key.lower()):
                if value != None:
                    self.set_property(IDS[key.lower()],unicode(value[len(value)-1]))

        self.set_property("bitrate",f.bitrate(-1))
        duration = f.time_total(-1)*1000
        duration = "%d"%duration
        try: duration = duration[duration.rindex(".")+1:]
        except : pass
        self.set_property("duration",int(duration))

    def read_from_mpc_file(self):
        IDS = {
            "title": "title",
            "artist": "artist",
            "album": "album",
            "tracknumber": "tracknr",
        }
        SDI = dict([(v, k) for k, v in IDS.iteritems()])

        tag = musepack.APETag(self.get_path())
        for key, value in tag:
            key = MPCFile.TRANS.get(key.lower(), key.lower())
            if (value.kind == musepack.apev2.TEXT):
                if IDS.has_key(key.lower()):
                    #value = utils.escape("\n".join(list(value)))

                    #Only take the first element no multiple tag support
                    value = utils.escape(list(value)[0])
                    self.db.set_media_property(self.id,IDS[key.lower()],value)


        f = musepack.MPCFile(self.get_path())
        self.set_property("duration",int(f.length / 1000))
        try: self.set_property("bitrate", int(f.bitrate))
        except AttributeError: pass

    def read_from_mp4_file(self):
        try:
            f = _mp4v2.MP4Read(self.get_path(), ctypes.c_uint32(0))
            if not f: raise IOError("%s not an MP4 file" % self.get_path())

            numtracks = _mp4v2.MP4GetNumberOfTracks(f, None, ctypes.c_uint8(0))
            for i in range(numtracks):
                trackid = _mp4v2.MP4FindTrackId(
                    f, ctypes.c_uint16(i), None, ctypes.c_uint8(0))
                tracktype = _mp4v2.MP4GetTrackType(f, ctypes.c_uint8(trackid))
                if tracktype == "soun": track = trackid
            else: track = -1

            if track == -1: raise IOError("%s has no audio track"%self.get_path())
            duration = _mp4v2.MP4GetTrackDuration(f, ctypes.c_uint32(track))
            length = _mp4v2.MP4ConvertFromTrackDuration(
                f, ctypes.c_uint32(track), ctypes.c_uint32(duration),
                ctypes.c_uint32(1))
            self.set_property("duration",int(length))


            from ctypes import byref
            for key, function in [
                ("title", _mp4v2.MP4GetMetadataName),
                ("artist", _mp4v2.MP4GetMetadataArtist),
                #("composer", _mp4v2.MP4GetMetadataWriter),
                #("comment", _mp4v2.MP4GetMetadataComment),
                #("date", _mp4v2.MP4GetMetadataYear),
                ("album", _mp4v2.MP4GetMetadataAlbum),
                #("encoder", _mp4v2.MP4GetMetadataTool),
                #("genre", _mp4v2.MP4GetMetadataGenre)
                ]:
                value = ctypes.c_char_p()
                if function(f, byref(value)):
                    self.set_media_property(key,value.value.decode('utf-8'))

            cur, total = ctypes.c_uint16(), ctypes.c_uint()
            if _mp4v2.MP4GetMetadataTrack(f, byref(cur), byref(total)):
                self.set_media_property("tracknr",cur.value)

        finally:
            _mp4v2.MP4Close(f)


    """""""""""""""""""""
        FILE WRITER
    """""""""""""""""""""
    def write(self):
        if  self.write_to_file():
            return True
        else:
            return False


    def write_to_file(self):
        if self.get_protocol()!="file://":
            self.last_error = self.get_protocol()+" "+_("Protocol not supported")
            return False
        if not os.path.exists(self.get_path()):
            self.last_error = self.get_filename()+_(" doesn't exist")
            return False
        if self.get_ext() not in WRITE_EXTENTIONS:
            self.last_error = self.get_filename()+_(": file formats don't support tag writting")
            return False
        if not os.access(self.get_path(),os.W_OK):
            self.last_error = self.get_filename()+_(" doesn't have enough permission")
            return False

        func = {
            '.mp3' : lambda: self.write_to_mp3_file(),
            '.mp2' : lambda: self.write_to_mp3_file(),
            '.ogg' : lambda:  self.write_to_ogg_file(),
            '.flac' : lambda: self.write_to_flac_file()
        }[self.get_ext()]

        try: func()
        except:
            self.last_error = _("Error while writing")+": "+self.get_filename()
            return False
        else:
            return True

    def write_to_mp3_file(self):
        IDS = {
            "TIT2": "title",
            "TPE1": "artist",
            "TALB": "album",
            "TRCK": "tracknr",
        }
        SDI = dict([(v, k) for k, v in IDS.iteritems()])
        try: tag = mutagen.id3.ID3(self.get_path())
        except mutagen.id3.error: tag = mutagen.id3.ID3()
        for key, value in IDS.iteritems():
            tag_value = self.sprint(value)
            tag.delall(key)
            if tag_value!="":
               Kind = mutagen.id3.Frames[key]
               tag.loaded_frame(Kind(encoding=3, text=tag_value))
        tag.save(self.get_path())

    def write_to_ogg_file(self):
        IDS = {
            "title": "title",
            "artist": "artist",
            "album": "album",
            "track": "tracknr",
        }
        SDI = dict([(v, k) for k, v in IDS.iteritems()])
        f = ogg.vorbis.VorbisFile(self.get_path())
        comments = f.comment()
        #comments.clear()
        for key,value in IDS.iteritems():
            value = self.sprint(value)
            del comments[key]
            if value!="":
                comments[key] = value

        comments.write_to(self.get_path())

    def write_to_flac_file(self):
        IDS = {
            "title": "title",
            "artist": "artist",
            "album": "album",
            "tracknumber": "tracknr",
        }
        f = mutagen.flac.FLAC(self.get_path())
        if f.vc is None: f.add_vorbiscomment()
        del(f.vc[:])
        for key,value in IDS.iteritems():
            value = self.sprint(value)
            if value!="":
                f.vc[key] = value
        f.save()

    def update_play_information(self):
        self.playcount = self.playcount+1
        self.last_played = time()

    def filename(self):
        return utils.get_filename(self.uri)

    def get_path(self):
        return utils.fsencode(utils.get_path(self.uri))

    def get_protocol(self):
        return utils.get_protocol(self.uri)

    def get_ext(self,complete=True):
        return utils.get_ext(self.uri,complete)

    def get_filename(self):
        return utils.get_filename(self.uri)

    def get_error(self):
        return self.last_error

    def remove_album_art(self):
        image_path = self.get_album_art_path()
        if image_path in SKIP_ALBUM_COVER:
            del SKIP_ALBUM_COVER[SKIP_ALBUM_COVER.index(image_path)]
        if os.path.exists(image_path):
            os.unlink(image_path)

    def get_album_art_search_str(self):
        art = ""
        if self.sprint("artist")!="":
            art=self.sprint("artist")+"+"
        if self.sprint("album")!="":
            art+=self.sprint("album")
        art = utils.filtre_info_song(art).encode('utf-8')
        return art
    #Return path of the local album art(can not really exist)
    def get_album_art_path(self):
        return config.CONFIG_DIR+"cover/"+self.get_album_art_search_str()+".jpg"

    #Return path of the album art to display
    def get_album_art(self,callback=None):#callback(filename) don't work i wan't wait a other idea

        basedir = os.path.dirname(os.path.realpath(__file__))+"/"
        art = utils.filtre_info_song(self.get_album_art_search_str()).encode('utf-8')

        image_path = config.CONFIG_DIR+"cover/"+art+".jpg"
        if os.path.exists(image_path):
            return image_path
        else:
            if image_path in SKIP_ALBUM_COVER:
                return basedir+config.PIXMAP_DIR+"listen_cover.png"

            #search in local directory
            #artist.jpg,folder.jpg,album.jpg and same with png
            if self.uri!=None and self.get_protocol()=="file://":
                filename = self.get_path()
                path = filename[:filename.rfind("/")]
                list_file = os.listdir(path)
                for f in list_file:
                    #print f.lower()
                    if f.lower() in ["artist.jpg","folder.jpg","album.jpg","artist.png","folder.png","album.png"]:
                        pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(path+"/"+f,75,75)
                        if os.path.exists(image_path):
                            os.unlink(image_path)
                        pixbuf.save(image_path, "jpeg", {"quality":"85"})
                        del pixbuf
                        #print "Local cover found: ",f
                        return image_path

            # Search on amazon
            amazon.setLicense("0RKH4ZH1JCFZHMND91G2")
            try:
                bags = amazon.searchByKeyword(art,type="lite", product_line="music")
            except:
                if callback==None:
                    return basedir+config.PIXMAP_DIR+"listen_cover.png"
                else:
                    callback(basedir+config.PIXMAP_DIR+"listen_cover.png")
            else:
                #for bag in bags: pass
                #sock = urllib.urlopen(bags[0].ImageUrlSmall)
                if callback==None:
                    res = urllib.urlretrieve(bags[0].ImageUrlSmall, image_path)
                    if res:
                        #Change resolution
                        pixbuf = gtk.gdk.pixbuf_new_from_file_at_size(image_path,75,75)
                        if os.path.exists(image_path):
                            os.unlink(image_path)
                        pixbuf.save(image_path, "jpeg", {"quality":"85"})
                        del pixbuf
                        return image_path
                    else:
                        SKIP_ALBUM_COVER.append(image_path)
                        return basedir+config.PIXMAP_DIR+"listen_cover.png"
                else:
                    def download_cb(pixbuf,filename,callback):
                        pixbuf = loader.get_pixbuf();
                        pixbuf.save(filename, "jpeg", {"quality":"85"})
                        callback(filename)
                    sock = urllib.urlopen(bags[0].ImageUrlSmall)
                    loader = gtk.gdk.PixbufLoader()
                    loader.connect("closed", download_cb,image_path,callback)
                    loader.write(sock.read())
                    sock.close()
                    loader.close()


    """
        IPOD FUNCTION
    """

    def read_from_ipod_track(self,track,mount_point):

        self.set_property("ipod_track",track)
        self.set_property("ipod_id",track.id)
        self.set_property("title",track.title)
        self.set_property("album",track.album)
        self.set_property("artist",track.artist)
        self.set_property("duration",track.tracklen)
        if track.track_nr!=0:
            self.set_property("tracknr",track.track_nr)
        else:
            self.set_property("tracknr",None)
        file = gpod.itdb_filename_on_ipod(track)
        if file is not None:
            self.set_property("uri", "file://"+file)
        self.set_property("ipod_mount_point",mount_point)
        self.tagged=True



    def get_ipod_track(self ):
        file = utils.fsencode(self.get_path())
        if not os.path.exists(file):
            return None

        track = gpod.itdb_track_new()
        if self.sprint("title")!="": track.title = str(self.sprint("title"))
        #else: track.title = ""
        if self.sprint("album")!="": track.album = str(self.sprint("album"))
        #else: track.album = ""
        if self.sprint("artist")!="": track.artist = str(self.sprint("artist"))
        #else: track.artist = ""
        """
        if self.sprint("genre") and self["genre"]!=None: track.genre = str(self["genre"])
        else: track.genre = "Rock"
        if self.sprint("comment") and self["comment"]!=None: track.comment = str(self["comment"])
        else: track.comment = ""
        if self.sprint("composer") and self["composer"]!=None: track.composer = str(self["composer"])
        else: track.composer = ""
        if self.sprint("grouping") and self["grouping"]!=None: track.grouping = str(self["grouping"])
        else: track.grouping = ""
        if self.sprint("category") and self["category"]!=None: track.category = str(self["category"])
        else: track.category = ""
        if self.sprint("description") and self["description"]!=None: track.description = str(self["description"])
        else: track.description = ""
        if self.sprint("album") and self["album"]!=None: track.album = str(self["album"])
        else: track.album = ""
        if self.sprint("podcasturl") and self["podcasturl"]!=None: track.podcasturl = str(self["podcasturl"])
        else: track.podcasturl = ""
        if self.has_key("podcastrss") and self["podcastrss"]!=None: track.podcastrss = str(self["podcastrss"])
        else: track.podcastrss = ""
        if self.has_key("subtitle") and self["subtitle"]!=None: track.subtitle = str(self["subtitle"])
        else: track.subtitle = ""
        """
        """if self.sprint("ipod_path")!="" : track.ipod_path = str(self.sprint("ipod_path"))
        else: track.ipod_path = """""

        if self.sprint("tracknr") !="" :
            track.track_nr = long(self.get_property("tracknr"))
        #else: track.track_nr = long(0)
        if self.sprint("duration") !="" :
             track.tracklen = long(self.get_property("duration"))
        #else: track.tracklen = long(0)

        """track.cd_nr = long(0)
        track.cds = long(0)"""
        if self.sprint("bitrate") !="" : track.bitrate = long(self.get_property("bitrate"))
        #else: track.bitrate  = long(0)

        if self.size !=None : track.size = long(self.size)
        #else: track.bitrate  = long(0)


        track.filetype = "MPEG audio file"
        track.time_added = long(utils.time_unix_to_mac(time()))
        track.time_modified = track.time_added


        art = self.get_album_art()
        if os.path.exists(art):

            if gpod.itdb_track_set_thumbnails(track,str(art)) == 0:
                print "Failed to save image thumb for ",self.title
            #else:
            #    print "Thumbnail saved"
        """

                if self.has_key("artist") and self["artist"]:
                    str_search=self["artist"]+"+"
                if self.has_key("album") and self["album"]:
                    str_search+=self["album"]
                str_search = utils.filtre_info_song(str_search).encode('utf-8')
                art = config.CONFIG_DIR+"cover/"+str_search+".jpg"
                if os.path.exists(art):
                    print art
                    if gpod.itdb_track_set_thumbnails(track,art) == 0:
                        print "Failed to save image thumbnail"
                    else:
                        print track.orig_image_filename
                        print "image thumbnail added"
                else:
                    print "art not exist:",art
        """
        return track
