###
#
# Listen is the legal property of mehdi abaakouk <theli48@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###

import gtk


import config
from db_manager import DBManager
from view_song import *


class ListenUIBrowserView(gtk.VPaned):
    def __init__(self,media_organizer,treeview_song = None):
        self.media_organizer = media_organizer
        self.player = media_organizer.player
        gtk.VPaned.__init__(self)
        """
            SONG
        """
        if treeview_song == None:
            self.treeview_song = ListenUITreeviewSong(media_organizer)
        else:
            self.treeview_song = treeview_song

        """
            ARTIST
        """
        self.model_artist = gtk.ListStore(gobject.TYPE_STRING,gobject.TYPE_INT,gobject.TYPE_STRING,gobject.TYPE_STRING)
        #self.model_artist = self.model_artist_orig

        self.renderer_artist = gtk.CellRendererText()
        self.renderer_artist.set_property("ellipsize",pango.ELLIPSIZE_END)
        self.renderer_artist_nb_album = gtk.CellRendererText()
        self.renderer_artist_nb_song = gtk.CellRendererText()
        self.renderer_artist_nb_album .set_property("xalign",1)
        self.renderer_artist_nb_song.set_property("xalign",1)


        self.column_artist = gtk.TreeViewColumn(_("Artists"))
        column_artist1 = gtk.TreeViewColumn(_("Al."))
        column_artist1.set_alignment(1)
        column_artist2 = gtk.TreeViewColumn(_("So."))
        column_artist2.set_alignment(1)
        self.column_artist.pack_start(self.renderer_artist,True)
        column_artist1.pack_start(self.renderer_artist_nb_album,True)
        column_artist2.pack_start(self.renderer_artist_nb_song,True)
        self.column_artist.set_cell_data_func(self.renderer_artist, self.__cell_data_func_artist)
        column_artist1.set_cell_data_func(self.renderer_artist_nb_album, self.__cell_data_func_nb_album)
        column_artist2.set_cell_data_func(self.renderer_artist_nb_song, self.__cell_data_func_nb_song)
        self.column_artist.set_expand(True)
        self.column_artist.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE);

        self.treeview_artist = gtk.TreeView()
        self.treeview_artist.append_column(self.column_artist)
        self.treeview_artist.append_column(column_artist1)
        self.treeview_artist.append_column(column_artist2)
        #self.treeview_artist.set_model(self.model_artist)
        self.treeview_artist.get_selection().set_mode(gtk.SELECTION_MULTIPLE)
        self.treeview_artist.get_selection().connect("changed", self.on_row_artist_selected)
        self.treeview_artist.connect("row-activated",self.on_row_activated)
        self.treeview_artist.set_search_equal_func(self.on_artist_search)

        self.treeview_artist.enable_model_drag_source(gtk.gdk.BUTTON1_MASK|gtk.gdk.SHIFT_MASK|gtk.gdk.CONTROL_MASK,
                                                  [("text/uri-list", 0, 0)],
                                                  gtk.gdk.ACTION_COPY)

        self.treeview_artist.connect("drag-data-get", self.on_medialib_drag_data_get)

        self.treeview_artist.set_rules_hint(True)
        """
            ALBUM
        """
        self.model_album = gtk.ListStore(gobject.TYPE_STRING,gobject.TYPE_INT,gobject.TYPE_STRING)
        #self.model_album = self.model_album_orig.filter_new()

        self.renderer_album = gtk.CellRendererText()
        self.renderer_album.set_property("ellipsize",pango.ELLIPSIZE_END)
        self.renderer_album_nb_song = gtk.CellRendererText()
        self.renderer_album_nb_song.set_property("xalign",1)
        self.column_album = gtk.TreeViewColumn(_("Albums"))
        column_album1 = gtk.TreeViewColumn(_("So."))
        column_album1.set_alignment(1)
        column_album1.pack_start(self.renderer_album_nb_song,True)
        self.column_album.pack_start(self.renderer_album,True)
        self.column_album.set_cell_data_func(self.renderer_album, self.__cell_data_func_album)
        column_album1.set_cell_data_func(self.renderer_album_nb_song, self.__cell_data_func_nb_song)
        self.column_album.set_expand(True)
        self.column_album.set_sizing(gtk.TREE_VIEW_COLUMN_AUTOSIZE)

        self.treeview_album = gtk.TreeView()
        self.treeview_album.append_column(self.column_album)
        self.treeview_album.append_column(column_album1)
        #self.treeview_album.set_model(self.model_album)
        self.treeview_album.get_selection().set_mode(gtk.SELECTION_MULTIPLE)
        self.treeview_album.get_selection().connect("changed", self.on_row_album_selected)
        self.treeview_album.set_search_equal_func(self.on_album_search)
        self.treeview_album.connect("row-activated",self.on_row_activated)

        self.treeview_album.enable_model_drag_source(gtk.gdk.BUTTON1_MASK|gtk.gdk.SHIFT_MASK|gtk.gdk.CONTROL_MASK,
                                                  [("text/uri-list", 0, 0)],
                                                  gtk.gdk.ACTION_COPY)

        self.treeview_album.connect("drag-data-get", self.on_medialib_drag_data_get)

        self.treeview_album.set_rules_hint(True)

        """
            DIVERS
        """
        scroll1 = gtk.ScrolledWindow()
        scroll1.set_policy(gtk.POLICY_NEVER,gtk.POLICY_AUTOMATIC)
        scroll1.add(self.treeview_artist)
        scroll1.set_shadow_type(gtk.SHADOW_IN)

        scroll2 = gtk.ScrolledWindow()
        scroll2.set_policy(gtk.POLICY_NEVER,gtk.POLICY_AUTOMATIC)
        scroll2.add(self.treeview_album)
        scroll2.set_shadow_type(gtk.SHADOW_IN)


        scroll3 = gtk.ScrolledWindow()
        scroll3.set_policy(gtk.POLICY_NEVER,gtk.POLICY_AUTOMATIC)
        scroll3.add(self.treeview_song)
        scroll3.set_shadow_type(gtk.SHADOW_IN)
        scroll3.set_size_request(-1,250)

        hbox = gtk.HBox(True,4)
        hbox.pack_start(scroll1)
        hbox.pack_start(scroll2)

        self.pack1(hbox,False,True)
        self.pack2(scroll3,True,False)
        self.compute_position(-1,200,250)
        #self.set_position(270)
        self.set_position(int(config.get("setting","pos_browser")))

        self.update_view = True
        self.album_idle=None
        self.artist_idle=None
        self.update_timeout_id = None

        self.last_select_artist = {}
        self.last_select_album = {}

        if treeview_song == None:
            artists = config.get("setting","last_selected_artist")
            if artists != "":
                for name in artists.split("<#>"):
                    self.last_select_artist[name]=None
            albums = config.get("setting","last_selected_album")
            if albums != "":
                for name in albums.split("<#>"):
                    self.last_select_album[name]=None

        self.remplisage_en_cours = False
        self.__sig = None
        self.treeview_song.set_model(self.treeview_song.model_song)


    """""""""""""""""""""""""""
        FUNC SELECTION
    """""""""""""""""""""""""""
    def get_selected_artist(self):
        model_artist, rows_artist = self.treeview_artist.get_selection().get_selected_rows()
        artist = ""
        sep = ""
        if len(rows_artist)<=0:
            return None
        for row in rows_artist:
            value = model_artist.get_value(model_artist.get_iter(row[0]),0)
            if value.find("######")==0: continue
            artist += sep +"'"+ utils.escape(value )+"'"
            sep= ","

        return artist

    def get_selected_artist_list(self):
        model_artist, rows_artist = self.treeview_artist.get_selection().get_selected_rows()
        artist = []
        if len(rows_artist)<=0:
            return None
        self.last_select_artist = {}
        for row in rows_artist:
            iter = model_artist.get_iter(row[0])
            value = model_artist.get_value(iter,0)
            self.last_select_artist[value] = iter
            artist.append(value)

        return artist

    def get_selected_album(self):
        model_album, rows_album = self.treeview_album.get_selection().get_selected_rows()
        if len(rows_album)<=0:
            return None
        album = ""
        sep = ""
        for row in rows_album:
            value = model_album.get_value(model_album.get_iter(row[0]),0)
            if value.find("######")==0: continue
            album += sep +"'"+ utils.escape(value)+"'"
            sep= ","

        return album

    def get_selected_album_list(self):
        model_album, rows_album = self.treeview_album.get_selection().get_selected_rows()
        album = []
        if len(rows_album)<=0:
            return None
        self.last_select_album = {}
        for row in rows_album:
            iter = model_album.get_iter(row[0])
            value = model_album.get_value(iter,0)
            self.last_select_album[value] = iter
            album.append(value)

        return album
    """""""""""""""""""""
        FUNC POPULATE
    """""""""""""""""""""


    def refresh_cache(self,DB=DBManager):
        #Warning DB parameter is only for boost startup
        #I one more DB used :
        # you will have a sqlite thread problem
        # OR a risk to desyncronize file with treeview and loose information
        self.albums = DB.get_albums()
        self.artists = DB.get_artists()
        self.songs_cache = DB.get_all_songs();


    def populate_view(self):

        self.treeview_artist.set_model(None)
        self.model_artist.clear()
        self.treeview_album.set_model(None)
        self.model_album.clear()
        """self.treeview_song.set_model(None)
        self.treeview_song.model_song.clear()"""

        """ POPULATE ARTISTS """
        #artists = self.db.select_request("SELECT * FROM artists ORDER by LOWER(artist);");
        artists = self.artists
        self.column_artist.set_title(_("Artists")+" (%d)"%len(artists))
        album_total = 0
        song_total = 0
        new_select_artist = {}
        self.last_artist={"artist":"","nb_song":"0","nb_album":"0"}
        for artist in artists:
            #print artist
            album_total += int(artist["nb_album"])
            song_total += int(artist["nb_song"])
            if self.last_artist["artist"]!=artist["artist"]:
                if self.last_artist["nb_song"]!="0":
                    iter = self.model_artist.append((self.last_artist["artist"],0,self.last_artist["nb_song"],self.last_artist["nb_album"]))
                    if self.last_select_artist.has_key(self.last_artist["artist"]):
                        new_select_artist[self.last_artist["artist"]]=iter
                self.last_artist = artist
            else:
                self.last_artist["nb_song"] = int(self.last_artist["nb_song"]) + int(artist["nb_song"])
                self.last_artist["nb_album"] = int(self.last_artist["nb_album"]) + int(artist["nb_album"])

        iter = self.model_artist.append((self.last_artist["artist"],0,self.last_artist["nb_song"],self.last_artist["nb_album"]))

        if self.last_select_artist.has_key(self.last_artist["artist"]):
            new_select_artist[self.last_artist["artist"]]=iter


        self.last_select_artist = new_select_artist
        #self.model_artist.append((artist["artist"],0,artist["nb_song"],artist["nb_album"]))

        iter = self.model_artist.insert(0,("######",1,"%d"%song_total,"%d"%album_total))
        self.treeview_artist.set_model(self.model_artist)

        if len(self.last_select_artist)<=0:
            self.treeview_artist.get_selection().select_iter(iter)
        else:
            first = True
            for key,value in self.last_select_artist.iteritems():
                if first:
                    path = self.model_artist.get_path(value)
                    self.treeview_artist.scroll_to_cell(path)
                    first=False

                self.treeview_artist.get_selection().select_iter(value)


    def on_row_artist_selected(self,treeselection):
        if not self.update_view: return
        self.treeview_album.set_model(None)
        self.model_album.clear()

        artist = self.get_selected_artist_list()
        if artist == None:
            return
        new_select_album = {}
        song_total = 0
        albums = self.albums
        self.last_album={"album":"","artist":"","nb_song":"0"}
        for album in albums:
            if  "######" in artist or album["artist"] in artist:
                song_total += int(album["nb_song"])
                if self.last_album["album"]!=album["album"]:
                    if self.last_album["nb_song"]!="0":
                        iter = self.model_album.append((self.last_album["album"],0,self.last_album["nb_song"]))
                        if self.last_select_album.has_key(self.last_album["album"]):
                            new_select_album[self.last_album["album"]]=iter
                    self.last_album = album
                else:
                    self.last_album["nb_song"] = int(self.last_album["nb_song"]) + int(album["nb_song"])

        iter = self.model_album.append((self.last_album["album"],0,self.last_album["nb_song"]))
        if self.last_select_album.has_key(self.last_album["album"]):
            new_select_album[self.last_album["album"]]=iter

        self.last_select_album = new_select_album

        self.column_album.set_title(_("Albums")+" (%d)"%len(self.model_album))

        iter = self.model_album.insert(0,("######",1,"%d"%song_total))

        self.treeview_album.set_model(self.model_album)

        if len(self.last_select_album)<=0:
            self.treeview_album.get_selection().select_iter(iter)
        else:
            first = True
            for key,value in self.last_select_album.iteritems():
                if first:
                    path = self.model_album.get_path(value)
                    self.treeview_album.scroll_to_cell(path)
                    first=False
                self.treeview_album.get_selection().select_iter(value)


    def on_row_album_selected(self, treeselection):
        """if self.album_idle!=None: gobject.source_remove(self.album_idle)
        self.album_idle=None"""
        if not self.update_view: return
        if self.__sig!=None : gobject.source_remove(self.__sig)
        self.__sig = None
        while self.remplisage_en_cours: pass
        #self.treeview_song.set_model(None)
        self.treeview_song.model_song.clear()

        artist = self.get_selected_artist_list()
        if artist == None:
            return
        album = self.get_selected_album_list()
        if album == None:
            return
        songs = self.songs_cache;
        song_to_add = []
        for song in songs:
            if ("######" in artist or song.sprint("artist") in artist) and ("######" in album or song.sprint("album") in album):
                song_to_add.append(song)

        self.__sig = gobject.idle_add(self.__idle_add,song_to_add)


    def __idle_add(self,songs_to_add):
        self.remplisage_en_cours=True
        if self.__sig!=None : gobject.source_remove(self.__sig)
        self.__sig = None
        songs = songs_to_add[:100]
        for song in songs:
            self.treeview_song.model_song.append((song,song.get_int("tracknr"),song.sprint("title"),song.get_property("duration"),song.sprint("artist"),song.sprint("album") ))
        if len(songs_to_add[101:])>0:
            self.__sig = gobject.idle_add(self.__idle_add,songs_to_add[101:])
        self.remplisage_en_cours=False
        #self.treeview_song.set_model(self.treeview_song.model_song)


    def on_row_activated(self,treeview, path, view_column):
        #attente de replissage du treeview des chansons
        while self.__sig != None:gtk.main_iteration()

        play = True
        for row in self.treeview_song.model_song:
            self.player.playlist.add_song(row[0],False,play)
            play = False
    """""""""""""""""""""""""""""
        FUNC RECHERCHE TREEVIEW
    """""""""""""""""""""""""""""
    def on_artist_search(self,model, column, key, iterator):

        self.update_view = False
        if self.update_timeout_id!=None:
            gobject.source_remove(self.update_timeout_id)
        self.update_timeout_id = gobject.timeout_add(500,self.interactive_search_finish_cb,self.on_row_artist_selected)
        artist = model.get_value(iterator, 0)
        if artist.lower().find(key.lower()) == 0:
          return False
        return True

    def on_album_search(self,model, column, key, iterator):
        self.update_view = False
        if self.update_timeout_id!=None:
            gobject.source_remove(self.update_timeout_id)
        self.update_timeout_id = gobject.timeout_add(500,self.interactive_search_finish_cb,self.on_row_album_selected)
        album = model.get_value(iterator, 0)
        if album.lower().find( key.lower()) == 0:
          return False
        return True

    def interactive_search_finish_cb(self,func):
        self.update_view = True
        self.update_timeout_id = None
        func(None)

    """""""""""""""""""""""
        CELL RENDER FUNC
    """""""""""""""""""""""
    def __cell_data_func_artist(self, column, cell, model, iter):
        type = model.get_value(iter, 1)
        value = model.get_value(iter, 0)
        if type==1:
            text  = "<b>"+_("All")+"</b>"
        elif value == "":
            text = "<i>("+_("Inconnus")+")</i>"
        else:
            text = xml.sax.saxutils.escape(value)
        if config.get("setting","mlib_smallfont")=="true":
            text="<span size=\"small\">"+text+"</span>"
        cell.set_property("markup",text )


    def __cell_data_func_album(self, column, cell, model, iter):
        type = model.get_value(iter, 1)
        value = model.get_value(iter, 0)
        if type==1:
            text  = "<b>"+_("All")+"</b>"
        elif value == "":
            text = "<i>("+_("Inconnus")+")</i>"
        else:
            text = xml.sax.saxutils.escape(value)
        if config.get("setting","mlib_smallfont")=="true":
            text="<span size=\"small\">"+text+"</span>"
        cell.set_property("markup",text )

    def __cell_data_func_nb_song(self, column, cell, model, iter):
        text = model.get_value(iter, 2)
        cell.set_property("markup", text)

    def __cell_data_func_nb_album(self, column, cell, model, iter):
        text = model.get_value(iter, 3)
        cell.set_property("markup", text)
    """""""""""""""""""""
        FUNC DRAG DROP
    """""""""""""""""""""

    def on_medialib_drag_data_get(self,treeview, context, selection, info, timestamp):
        #print "SONG VIEW : drop data get"
        list_uri = []
        list_song = []
        while self.__sig!=None:gtk.main_iteration()
        for row in self.treeview_song.model_song:
            list_song.append(row[0])
            uri = utils.convert_to_uri(row[0].get_property("uri"))
            list_uri.append(uri)
        self.get_toplevel().last_drag_drop = list_song

        selection.set_uris(list_uri)
