###
#
# Listen is the legal property of mehdi abaakouk <theli48@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
###

import os
import urllib
import urlparse
import gtkhtml2

opener = urllib.FancyURLopener()
opener.addheaders.pop(0)
opener.addheader("User-Agent","Mozilla")



HTML_TEMPLATE = """
        <html>
            <head>
                <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
                <style>*{
                         font-size:11px;
                        }
                        a{color:#A69F91}
                        a:hover{color:blue}
                        h1{font-size:16px;}
                        h2{font-size:14px;}
                        h3{font-size:12px;}
                        h4{font-size:11px;}
                        h5{font-size:10px;}
                        h6{font-size:8px;}
                       body{
                         margin:0px;
                         padding:7px;
                         font-size:11px;
                         background-color:white;
                        }
                        img{border:0px;}
                </style>
                </head>
            <body>
            <img style="float:right;margin-top:30px;margin-right:10px;" src="file://%s/images/bg_listen.png">
            %s
            </div>
            </body>
        </html>
                """%(os.getcwd(),"%s")

class HTMLDocument(gtkhtml2.Document):

    def __init__(self):
        gtkhtml2.Document.__init__(self)
        self.connect('request_url', self.request_url)
        self.base_uri=None


    def set_base_uri(self,base_uri):
        self.base_uri=base_uri

    def is_relative_to_server(self,url):
        parts = urlparse.urlparse(url)
        if parts[0] or parts[1]:
            return 0
        return 1

    def open_url(self,url,try_base_uri=True):
        #uri = self.resolve_uri(url)
        try:f = opener.open(url)
        except:
            if try_base_uri:
                return self.open_url(self.base_uri+url,False)
            else:
                print "link not found : ",url
                return None
        return f

    def resolve_uri(self,uri):
        if self.is_relative_to_server(uri):
            return urlparse.urljoin(self.current_url, uri)
        return uri

    def nothing(self,stream,two):
        #print "nothing",stream,two
        pass

    def request_url(self,document, url, stream,try_base_uri=True):
        stream.set_cancel_func(self.nothing)
        try: f = self.open_url(url)
        except:
            if try_base_uri:
                return self.request_url(document, self.base_uri+url, stream,False)
            else:
                print "not found : ",url
                return
        stream.write(f.read())
